> For the complete documentation index, see [llms.txt](https://docs.jentis.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.jentis.com/developer-guide.md).

# Developer Guide

- [Data Layer](https://docs.jentis.com/developer-guide/data-layer.md)
- [JENTIS Data Layer](https://docs.jentis.com/developer-guide/data-layer/jentis-data-layer.md)
- [Data Types in JENTIS Data Layer](https://docs.jentis.com/developer-guide/data-layer/jentis-data-layer/data-types-in-jentis-data-layer.md)
- [Content and Pageview Tracking](https://docs.jentis.com/developer-guide/data-layer/jentis-data-layer/content-and-pageview-tracking.md)
- [Custom Data Layer Definitions](https://docs.jentis.com/developer-guide/data-layer/jentis-data-layer/custom-data-layer-definitions.md)
- [States](https://docs.jentis.com/developer-guide/states.md)
- [JENTIS Data Layer State](https://docs.jentis.com/developer-guide/states/jentis-data-layer-state.md)
- [Triggers](https://docs.jentis.com/developer-guide/triggers.md)
- [JENTIS Click Trigger Details - Selectoraction](https://docs.jentis.com/developer-guide/triggers/jentis-click-trigger-details-selectoraction.md)
- [Variables](https://docs.jentis.com/developer-guide/variables.md)
- [Constant](https://docs.jentis.com/developer-guide/variables/constant.md)
- [Client-Side Variables](https://docs.jentis.com/developer-guide/variables/client-side-variables.md)
- [Function - Arguments](https://docs.jentis.com/developer-guide/variables/client-side-variables/function-arguments.md)
- [element](https://docs.jentis.com/developer-guide/variables/client-side-variables/function-arguments/element.md)
- [accountvars](https://docs.jentis.com/developer-guide/variables/client-side-variables/function-arguments/accountvars.md)
- [stateContext](https://docs.jentis.com/developer-guide/variables/client-side-variables/function-arguments/statecontext.md)
- [Public Function Scope](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope.md)
- [variableid](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/variableid.md)
- [triggername](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/triggername.md)
- [setCookie](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/setcookie.md)
- [readCookie](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/readcookie.md)
- [setServerCookie](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/setservercookie.md)
- [setLocalStorageItem](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/setlocalstorageitem.md)
- [getLocalStorageItem](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/getlocalstorageitem.md)
- [getFrontendVariable](https://docs.jentis.com/developer-guide/variables/client-side-variables/public-function-scope/getfrontendvariable.md)
- [Asynchronous Variables](https://docs.jentis.com/developer-guide/variables/client-side-variables/asynchronous-variables.md)
- [Best Practices to Follow for Client-Side Variables](https://docs.jentis.com/developer-guide/variables/client-side-variables/best-practices-to-follow-for-client-side-variables.md)
- [Server-Side Variables](https://docs.jentis.com/developer-guide/variables/server-side-variables.md)
- [Public Function Scope](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope.md)
- [IP-Address](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/ip-address.md)
- [Timestamp](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/timestamp.md)
- [Container & Environment](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/container-and-environment.md)
- [Consent](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/consent.md)
- [accountvars](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/accountvars.md)
- [Log](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/log.md)
- [User Storage](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/user-storage-per-tool-instance.md)
- [Tool-Instance Storage](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/tool-instance-level-storage.md)
- [Global User Storage](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/global-user-storage.md)
- [getFrontendVariable](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/getfrontendvariable.md)
- [getConsentFromVendor](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/getconsentfromvendor.md)
- [generateRandomID](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/generaterandomid.md)
- [getHash](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/gethash.md)
- [getMD5](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/getmd5.md)
- [getSHA256](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/getsha256.md)
- [getHmacSHA1](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/gethmacsha1.md)
- [encodeBase64ToBase64Url](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/encodebase64tobase64url.md)
- [encodeBase64UrlToBase64](https://docs.jentis.com/developer-guide/variables/server-side-variables/public-function-scope/encodebase64urltobase64.md)
- [Data Enrichment](https://docs.jentis.com/developer-guide/variables/data-enrichment.md)
- [Server-Side Storage Interface](https://docs.jentis.com/developer-guide/server-side-storage-interface.md)
- [Storage Comparison](https://docs.jentis.com/developer-guide/server-side-storage-interface/storage-comparison.md)
- [Functions / Transformations](https://docs.jentis.com/developer-guide/functions-transformations.md)
- [Anonymization & Pseudonymization](https://docs.jentis.com/developer-guide/functions-transformations/anonymization-and-pseudonymization.md)
- [Codeblocks](https://docs.jentis.com/developer-guide/codeblocks.md)
- [Public Function Scope](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope.md)
- [triggername](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/triggername.md)
- [setCookie](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/setcookie.md)
- [readCookie](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/readcookie.md)
- [setLocalStorageItem](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/setlocalstorageitem.md)
- [getLocalStorageItem](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/getlocalstorageitem.md)
- [getFrontendVariable](https://docs.jentis.com/developer-guide/codeblocks/public-function-scope/getfrontendvariable.md)
- [Filter Variable in Tags](https://docs.jentis.com/developer-guide/filter-variable-in-tags.md)
- [Product Data Transposition](https://docs.jentis.com/developer-guide/filter-variable-in-tags/product-data-transposition.md)
- [Consent Javascript SDK](https://docs.jentis.com/developer-guide/consent-javascript-sdk.md)
- [Consent Processing Logic](https://docs.jentis.com/developer-guide/consent-javascript-sdk/consent-processing-logic.md)
- [Reprocessing in the Consent JavaScript SDK](https://docs.jentis.com/developer-guide/consent-javascript-sdk/reprocessing-in-the-consent-javascript-sdk.md)
- [Step-by-Step Use Case](https://docs.jentis.com/developer-guide/consent-javascript-sdk/reprocessing-in-the-consent-javascript-sdk/step-by-step-use-case.md)
- [Listening to the Consent JavaScript SDK](https://docs.jentis.com/developer-guide/consent-javascript-sdk/listening-to-the-consent-javascript-sdk.md)
- [JavaScript Events](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events.md)
- [vendor-change](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/vendor-change.md)
- [vendor-add](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/vendor-add.md)
- [init](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/init.md)
- [minimal-consent-given](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/minimal-consent-given.md)
- [no-consent-given](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/no-consent-given.md)
- [send-consent-data](https://docs.jentis.com/developer-guide/consent-javascript-sdk/javascript-events/send-consent-data.md)
- [SDK Functions](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions.md)
- [getVendorConsent](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getvendorconsent.md)
- [getAllConsents](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getallconsents.md)
- [getConsentData](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getconsentdata.md)
- [getConsentId](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getconsentid.md)
- [getVendorFullData](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getvendorfulldata.md)
- [getLastUpdateTime](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/getlastupdatetime.md)
- [setNewVendorConsents](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/setnewvendorconsents.md)
- [setConsentData](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/setconsentdata.md)
- [AcceptAll](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/acceptall.md)
- [DenyAll](https://docs.jentis.com/developer-guide/consent-javascript-sdk/sdk-functions/denyall.md)
- [Troubleshooting & Common Errors](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors.md)
- [Redirect on Landing Page](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/redirect-on-landing-page.md)
- [Console and INFO-Messages missing](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/console-and-info-messages-missing.md)
- [Navigation to tabs](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/navigation-to-tabs.md)
- [No Consent Connection](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/no-consent-connection.md)
- [No Tracking Activated](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/no-tracking-activated.md)
- [Click Tracking Troubleshooting](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/click-tracking-not-executed.md)
- [Click Tracking not executed - Further Troubleshooting](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/click-tracking-not-executed/click-tracking-not-executed-further-troubleshooting.md)
- [Click Tracking not executed - CSS and HTML issues](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/click-tracking-not-executed/click-tracking-not-executed-css-and-html-issues.md)
- [Click Tracking - Accessing Target URL Fails](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/click-tracking-not-executed/click-tracking-accessing-target-url-fails.md)
- [Click Tracking - Debug with All Clicks as a Last Resort Measure](https://docs.jentis.com/developer-guide/troubleshooting-and-common-errors/click-tracking-not-executed/click-tracking-debug-with-all-clicks-as-a-last-resort-measure.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.jentis.com/developer-guide.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
